"
This file is an extract from the collections-misc goody available
from the manchester goody archive. The original comment was:

        NAME            collections-misc
        AUTHOR          miw@cs.man.ac.uk (Mario Wolczko)
        FUNCTION        assorted collection-related things
        ST-VERSION      4.0 4.1
        PREREQUISITES   
        CONFLICTS
        DISTRIBUTION    world
        VERSION         2
        DATE            3 Dec 1991

SUMMARY This goodie contains a variety of methods and classes which
add functionality to collections.  Nothing is particularly startling,
but you may find the odd useful method.  I use these quite a lot.

Mario Wolczko

Dept. of Computer Science   Internet:      mario@cs.man.ac.uk
The University              uucp:        uknet!!man.cs!!mario
Manchester M13 9PL          JANET:         mario@uk.ac.man.cs
U.K.                        Tel: +44-61-275 6146  (FAX: 6236)

"

'From Smalltalk/X, Version:2.4.6 on 17-Dez-1992 at 19:56:22'!

Set subclass:#KeyedSet
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Collections-Unordered'
!

KeyedSet comment:
'A KeyedSet has the ability to locate an element of the set based on its hash,
using at:.'
!

!KeyedSet methodsFor:'accessing'!

at: key
        ^self at: key ifAbsent: [self errorNotFound]

        "
         |k|
         k := KeyedSet withAll:#('foo' 'bar').
         k at:'foo'
        "
!

at: key ifAbsent: aBlock
        | index |
        index := self find: key ifAbsent: [^aBlock value].
        ^ keyArray basicAt: index
! !

"COPYRIGHT.
 The above file is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
        * You must ensure that every copy includes this notice, and that
          source and author(s) of the material are acknowledged.
        * These conditions must be imposed on anyone who receives a copy.
        * The material shall not be used for commercial gain without the prior
          written consent of the author(s).
 Further information on the copyright conditions may be obtained by
 sending electronic mail:
        To: goodies-lib@cs.man.ac.uk
        Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1992 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
        To: goodies-lib@cs.man.ac.uk
        Subject: help 
"!
